import { ActionRowBuilder, ButtonBuilder, ButtonStyle, CacheType, ChatInputCommandInteraction, EmbedBuilder, Message } from "discord.js";
import ConfigManager from "./ConfigManager";
import axios from "axios";
import UserI from "../types/UserI";
import MessageI from "../types/MessageI";
import { channel } from "diagnostics_channel";

var isSyncing = false

export default class ChatController {
  public constructor() { }
  public async getMessages() {
    try {
      const { data, status } = await axios.get<MessageI[]>(`${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) return false

      console.log(data)

      return true
    } catch (error) {
      console.log(error)
    }
    return false
  }
  public async syncMessageWithDiscord() {
    if (isSyncing) return true

    isSyncing = true

    if (!global.config.chatChannelId) {
      isSyncing = false
      return false
    }

    try {
      const { data, status } = await axios.get<MessageI[]>(
        `${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat?startDay=${global.config.messages.length > 0 ? (global.config.messages[global.config.messages.length - 1].Timestamp / 3600 - 60).toFixed(10) : 0}`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) {
        isSyncing = false
        return false
      }

      if (data.length === 0) {
        isSyncing = false
        return true
      }

      const messages = data

      const ch = await global.client.channels.fetch(config.chatChannelId)
      if (!ch || !ch.isTextBased()) {
        isSyncing = false
        return false
      }

      messages.forEach(async m => {
        if (global.config.messages.filter(v =>
          m.Timestamp === v.Timestamp &&
          m.Text === v.Text &&
          m.Sender === v.Sender &&
          m.Receiver === v.Receiver
        ).length > 0) return
        else {
          // const me = new EmbedBuilder()
          // me.setDescription(m.Text)
          // me.setAuthor({ name: m.Sender })
          // ch.send({ embeds: [me] })
          await ch.send(`**${m.Sender}**: ${m.Text}`)

          global.config.messages.push(m)
        }
      })

      isSyncing = false
      return true
    } catch (error) {
      console.log(error)
    }

    isSyncing = false
    return false
  }
}